﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading.Tasks;

namespace Bravely_Default_SGE
{
    public partial class Form1 : Form
    {
        string filePath;

        /// <summary>
        /// Offset declarations:
        /// I think its selfexplanations 
        /// Here is the section, where the Offsets are definend
        /// </summary>
        #region Offset declarations

        static int moneyCountOffset = 0xBEEA;

        static int tizJobOffset = 0xC031;
        static int agnesJobOffset = 0xC5B8;
        static int edeaJobOffset = 0xD0C9;
        static int ringabelJobOffset=0xCB40;

        static int tizLvlOffset;
        static int agnesLvlOffset;
        static int edeaLvlOffset;
        static int ringabelLvlOffset;

        static int spellingsOffset = 0xBDFA;
        #endregion

        /// <summary>
        /// bytes declaration:
        /// Here you've got the defined how many bytes a entry has
        /// and the values of the bytes that will be replaced.
        /// </summary>
        #region bytes declaration & setting
        byte[] saveMoneyCount = new byte[4]; //Moneyvalue is splittet into 4 bytes

        //recommended mount of Money is 00FFFF4F = 4,194,300pg
        //max mount                     FFFFFF7F = 9,999,999pg
        static byte[] setMMoneyByte = new byte[4] { 255, 255, 255, 127};  //255 == FF 127 == 7F
        static byte[] setRMoneyByte = new byte[4] { 0, 255, 255, 79 };  //  0 == 00  255 == FF  79 == 4F


        byte[] tizJobs = new byte[51]; //Tiz seems to have only 51 bytes
        byte[] agnesJobs = new byte[64]; //Agnes has 64 bytes for here jobs
        byte[] edeaJobs = new byte[64]; //Edea has 64 bytes for here jobs
        byte[] ringabelJobs = new byte[64]; //Ringabel has 64 bytes for here jobs

        //https://gbatemp.net/threads/save-editing-bravely-default.373969/page-2#post-5664724 says CCCF is the right RedMage unfinished value
        static byte setJob1Byte = 204; //204 == CC
        static byte setJob2Byte = 207; //207 == CF

        byte[] tizJobMax = new byte[51] { 222, 241, 236, 120, 1, 246, 82, 246, 165, 198, 11, 170, 23, 15, 50, 112, 95, 194, 189, 28, 120, 121, 241, 98, 93, 40, 126, 222, 142, 151, 71, 48, 129, 94, 206, 187, 48, 123, 105, 239, 2, 231, 69, 223, 203, 208, 23, 71, 47, 112, 95 };
        byte[] agnesJobMax = new byte[64] { 0, 32, 202, 89, 50, 179, 7, 6, 212, 11, 57, 24, 170, 47, 96, 95, 202, 30, 13, 128, 193, 255, 194, 228, 197, 244, 139, 200, 23, 184, 48, 63, 94, 230, 189, 196, 94, 195, 243, 2, 156, 70, 47, 140, 148, 23, 137, 47, 117, 95, 146, 187, 88, 31, 242, 5, 156, 8, 240, 17, 0, 0, 0, 0 };
        byte[] edeaJobMax = new byte[63] { 176, 41, 103, 187, 203, 118, 23, 21, 48, 140, 94, 154, 187, 80, 128, 9, 240, 194, 78, 134, 50, 204, 136, 23, 38, 48, 70, 95, 150, 187, 60, 126, 161, 243, 2, 0, 192, 200, 140, 14, 24, 60, 47, 63, 95, 176, 189, 4, 125, 41, 239, 130, 129, 200, 18, 144, 34, 96, 85, 128, 150, 0, 0 };
        byte[] ringabelJobMax = new byte[64] { 0, 128, 160, 147, 19, 230, 189, 139, 21, 152, 37, 48, 112, 98, 106, 193, 168, 123, 49, 245, 2, 13, 6, 227, 11, 211, 23, 166, 47, 87, 94, 250, 187, 96, 120, 1, 0, 32, 4, 230, 210, 75, 186, 23, 238, 47, 182, 95, 128, 191, 228, 137, 153, 64, 100, 9, 60, 18, 200, 35, 0, 0, 0, 0 };



        byte[] tizLvl = new byte[4]; //till now not sure 4 is only a placeholder
        byte[] agnesLvl = new byte[4]; //till now not sure 4 is only a placeholder
        byte[] edeaLvl = new byte[4]; //till now not sure 4 is only a placeholder
        byte[] ringabelLvl = new byte[4]; //till now not sure 4 is only a placeholder

        byte[] spelling = new byte[160];
        static byte[] spelling1 = new byte[160] { 224, 0, 192, 2, 0, 7, 0, 19, 0, 60, 0, 124, 0, 88, 2, 192, 4, 160, 9, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
        static byte[] spelling6 = new byte[160] { 224, 0, 0, 2, 128, 4, 0, 10, 0, 22, 0, 48, 0, 104, 0, 224, 0, 224, 1, 0, 4, 128, 9, 0, 20, 0, 42, 0, 88, 0, 184, 0, 128, 1, 32, 3, 128, 6, 128, 13, 0, 28, 0, 58, 0, 120, 0, 248, 0, 0, 2, 32, 4, 128, 8, 128, 17, 0, 36, 0, 74, 0, 152, 0, 56, 1, 128, 2, 32, 5, 0, 11, 128, 22, 0, 52, 0, 106, 0, 216, 0, 184, 1, 128, 3, 32, 7, 128, 14, 128, 29, 0, 60, 0, 122, 0, 248, 0, 248, 1, 0, 4, 32, 8, 128, 16, 128, 33, 0, 68, 0, 138, 0, 24, 1, 56, 2, 128, 4, 32, 9, 128, 18, 128, 37, 0, 76, 0, 154, 0, 56, 1, 120, 2, 0, 5, 32, 10, 128, 20, 128, 41, 0, 84, 0, 170, 0, 88, 1, 184, 2, 128, 5, 32, 11, 128, 22, 128, 45, 0 };
        #endregion

        public Form1()
        {
            InitializeComponent();
            setAllOptionsInvisible();
        }

        #region StripMenu
        private void ladenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string path = "";
            openFileDialog1.Filter = "sav|GAME*.sav";
            openFileDialog1.Title = ".sav auswählen";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filePath = openFileDialog1.FileName;

                fillVars();

                #region enable stripbar elements
                speichernToolStripMenuItem.Enabled = true;
                gameXsavToolStripMenuItem.Enabled = true;
                path = filePath.Substring(0, filePath.Length - 9);

                if (File.Exists(path + "Game0.sav")) game1ToolStripMenuItem.Enabled = true;
                else game1ToolStripMenuItem.Enabled = false;

                if (File.Exists(path + "Game1.sav")) game2ToolStripMenuItem.Enabled = true;
                else game2ToolStripMenuItem.Enabled = false;

                if (File.Exists(path + "Game2.sav")) game2ToolStripMenuItem.Enabled = true;
                else game2ToolStripMenuItem.Enabled = false;

                #endregion
            }

        }
        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private void speichernToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (filePath != null)
            {
                Stream outStream = File.Open(filePath, FileMode.Open);
                outStream.Seek(moneyCountOffset, SeekOrigin.Begin);
                #region money
                for (int i = 0; i < saveMoneyCount.Count(); i++)
                {
                    outStream.WriteByte(saveMoneyCount[i]);
                }
                #endregion

                #region jobs
                outStream.Seek(tizJobOffset, SeekOrigin.Begin);
                for (int i = 0; i < tizJobs.Count(); i++)
                {
                    outStream.WriteByte(tizJobs[i]);
                }

                outStream.Seek(agnesJobOffset, SeekOrigin.Begin);
                for (int i = 0; i < agnesJobs.Count(); i++)
                {
                    outStream.WriteByte(agnesJobs[i]);
                }

                outStream.Seek(ringabelJobOffset, SeekOrigin.Begin);
                for (int i = 0; i < ringabelJobs.Count(); i++)
                {
                    outStream.WriteByte(ringabelJobs[i]);
                }

                outStream.Seek(edeaJobOffset, SeekOrigin.Begin);
                for (int i = 0; i < edeaJobs.Count(); i++)
                {
                    outStream.WriteByte(edeaJobs[i]);
                }
                #endregion

                outStream.Close();

                //this.Close();
            }
            else
            {
                MessageBox.Show("Missing File. \nPlease open the GAMEx.sav and do the edits again - Sorry.");
                labelMMoneyAll.Text = "";
                labelRMoneyAll.Text = "";
                labelTizJob.Text = "";
                labelAgnesJob.Text = "";
                labelEdeaJob.Text = "";
                labelRingabelJob.Text = "";

            }
        }

        private void game1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            filePath = filePath.Substring(0, filePath.Length - 9) + "Game0.sav";
            fillVars();
        }
        private void game2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            filePath = filePath.Substring(0, filePath.Length - 9) + "Game1.sav";
            fillVars();
        }
        private void game3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            filePath = filePath.Substring(0, filePath.Length - 9) + "Game2.sav";
            fillVars();
        }

        private void fillVars()
        {
            using (FileStream str = File.OpenRead(filePath))
            {
                str.Seek(moneyCountOffset, SeekOrigin.Begin);
                str.Read(saveMoneyCount, 0, saveMoneyCount.Count());

                #region read the jobs
                str.Seek(tizJobOffset, SeekOrigin.Begin);
                str.Read(tizJobs, 0, tizJobs.Count());

                str.Seek(agnesJobOffset, SeekOrigin.Begin);
                str.Read(agnesJobs, 0, agnesJobs.Count());

                str.Seek(edeaJobOffset, SeekOrigin.Begin);
                str.Read(edeaJobs, 0, edeaJobs.Count());

                str.Seek(ringabelJobOffset, SeekOrigin.Begin);
                str.Read(ringabelJobs, 0, ringabelJobs.Count());
                #endregion

                #region read the lvl
                str.Seek(tizLvlOffset, SeekOrigin.Begin);
                str.Read(tizLvl, 0, tizLvl.Count());

                str.Seek(agnesLvlOffset, SeekOrigin.Begin);
                str.Read(agnesLvl, 0, agnesLvl.Count());

                str.Seek(edeaLvlOffset, SeekOrigin.Begin);
                str.Read(edeaLvl, 0, edeaLvl.Count());

                str.Seek(ringabelLvlOffset, SeekOrigin.Begin);
                str.Read(ringabelLvl, 0, ringabelLvl.Count());
                #endregion

                #region spellings
                str.Seek(spellingsOffset, SeekOrigin.Begin);
                str.Read(spelling, 0, spelling.Count());

                string test = "";
                foreach (var ele in edeaJobs)
                {
                    test += ele + ",";
                }
                textBox2.Text = test;

                test = "";
                foreach (var ele in tizJobs)
                {
                    test += ele + ",";
                }
                textBox3.Text = test;

                test = "";
                foreach (var ele in agnesJobs)
                {
                    test += ele + ",";
                }
                textBox4.Text = test;

                test = "";
                foreach (var ele in edeaJobs)
                {
                    test += ele + ",";
                }
                textBox5.Text = test;

                test = "";
                foreach (var ele in ringabelJobs)
                {
                    test += ele + ",";
                }
                textBox6.Text = test;

                #endregion
                str.Close();
            }
        }

        private void infoToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("This tool is created by sweatbox for gbatemp.com\n\n " +
                            "Thanks goes to: \n" +
                            "- Oishikatta for the pionier work \n" +
                            "- ak!1 for his summory of his research \n" +
                            "- EclipseSin for his great work of all reseaches he did and support for this tool \n" +
                            "- Doredialilligan to support me with save-Datas, testing and keeping the thread alive");
        }
        #endregion

        #region set Money
        private void button_RMoney_Click(object sender, EventArgs e)
        {
            saveMoneyCount = setRMoneyByte;

            labelRMoney.Text = "ok";
            labelMMoney.Text = "";
            labelRMoneyAll.Text = "ok";
            labelMMoneyAll.Text = "";
        }
        private void button_MMoney_Click(object sender, EventArgs e)
        {
            saveMoneyCount = setMMoneyByte;

            labelMMoney.Text = "ok";
            labelRMoney.Text = "";
            labelMMoneyAll.Text = "ok";
            labelRMoneyAll.Text = "";
        }

        private void recMoney_Click(object sender, EventArgs e)
        {
            saveMoneyCount = setRMoneyByte;

            labelRMoney.Text = "ok";
            labelMMoney.Text = "";
            labelRMoneyAll.Text = "ok";
            labelMMoneyAll.Text = "";
        }
        private void maxMoney_Click(object sender, EventArgs e)
        {
            saveMoneyCount = setMMoneyByte;

            labelMMoney.Text = "ok";
            labelRMoney.Text = "";
            labelMMoneyAll.Text = "ok";
            labelRMoneyAll.Text = "";
        }
        #endregion

        /// <summary>
        /// Will overwrite the hole Jobbytes with declarated values 
        /// after pressing the button for the character.
        /// This is only Temporary. You will have to klick the
        /// Save Section in the StripMenu to write it back to file.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        #region set Jobs

        private void button_tizJob_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < tizJobs.Count(); i += 2)
            {
                tizJobs[i] = setJob1Byte;
                if (i < (tizJobs.Count() - 1)) tizJobs[i + 1] = setJob2Byte;
            }

            labelTizJob.Text = "ok";
        }

        private void button_agnesJob_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < agnesJobs.Count(); i += 2)
            {
                agnesJobs[i] = setJob1Byte;
                agnesJobs[i + 1] = setJob2Byte;
            }

            labelAgnesJob.Text = "ok";

        }

        private void button_edeaJob_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < edeaJobs.Count(); i += 2)
            {
                edeaJobs[i] = setJob1Byte;
                edeaJobs[i + 1] = setJob2Byte;
            }

            labelEdeaJob.Text = "ok";
        }

        private void button_ringabelJob_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < ringabelJobs.Count(); i += 2)
            {
                edeaJobs[i] = setJob1Byte;
                edeaJobs[i + 1] = setJob2Byte;
            }

            labelRingabelJob.Text = "ok";
        }

        private void comboBoxRingabelJob_SelectedIndexChanged(object sender, EventArgs e)
        {
            string selected = comboBoxRingableJob.SelectedItem.ToString();

            switch (selected)
            {
                case "Mastered": ringabelJobs = ringabelJobMax; break;
                default: MessageBox.Show("Not implimented"); break;
            }

        }
        private void comboBoxAgnesJob_SelectedIndexChanged(object sender, EventArgs e)
        {
            string selected = comboBoxAgnesJob.SelectedItem.ToString();

            switch (selected)
            {
                case "Mastered": agnesJobs = agnesJobMax; break;
                default: MessageBox.Show("Not implimented"); break;
            }
        }

        private void comboBoxTizJob_SelectedIndexChanged(object sender, EventArgs e)
        {
            string selected = comboBoxTizJob.SelectedItem.ToString();

            switch (selected)
            {
                case "Mastered": tizJobs = tizJobMax; break;
                default: MessageBox.Show("Not implimented"); break;
            }
        }

        private void comboBoxEdeaJob_SelectedIndexChanged(object sender, EventArgs e)
        {
            string selected = comboBoxEdeaJob.SelectedItem.ToString();

            switch (selected)
            {
                case "Mastered": edeaJobs = edeaJobMax; break;
                default: MessageBox.Show("Not implimented"); break;
            }
        }
        #endregion

        #region Spellings
        private void comboBox_spelling_SelectedIndexChanged(object sender, EventArgs e)
        {
            int spellingLvl = comboBox_spelling.SelectedIndex + 1;

            switch (spellingLvl)
            {
                case 1: spelling = spelling1; label3.Text = ""; break;
                case 6: spelling = spelling6; label3.Text = ""; break;
                default: label3.Text = "Not implemented. Please select 1 or 6"; break;

            }
        }
        #endregion

        #region GUI element visible/unvisible setting
        private void setAllOptionsInvisible()
        {
            o_money_Groupbox.Visible = false;
            o_onlyMax_Groupbox.Visible = false;
            o_spelling_Groupbox.Visible = false;
            o_tiz_Groupbox.Visible = false;
            o_agnes_Groupbox.Visible = false;
            o_ring_Groupbox.Visible = false;
            o_edea_Groupbox.Visible = false;

        }

        private void button_OnlyMax(object sender, EventArgs e)
        {
            setAllOptionsInvisible();
            o_onlyMax_Groupbox.Visible = true;
        }

        private void buttonMoney_Click(object sender, EventArgs e)
        {
            setAllOptionsInvisible();
            o_money_Groupbox.Visible = true;
        }

        private void buttonTiz_Click(object sender, EventArgs e)
        {
            setAllOptionsInvisible();
            o_tiz_Groupbox.Visible = true;
        }

        private void buttonSpellings_Click(object sender, EventArgs e)
        {
            setAllOptionsInvisible();
            labelspelling.Text = "Spellingslevel will always \n includes the lower once you selected! \n\n The Job maybe has to be modified as well.";
            o_spelling_Groupbox.Visible = true;

        }

       private void buttonAgnes_Click(object sender, EventArgs e)
        {
            setAllOptionsInvisible();
            o_agnes_Groupbox.Visible = true;
        }

       private void buttonRingabel_Click(object sender, EventArgs e)
       {
           setAllOptionsInvisible();
           o_ring_Groupbox.Visible = true;
       }
       private void buttonEdea_Click(object sender, EventArgs e)
       {
           setAllOptionsInvisible();
           o_edea_Groupbox.Visible = true;
       }
       private void buttonItems_Click(object sender, EventArgs e)
       {
           setAllOptionsInvisible();
           MessageBox.Show("Comming soon");
       }
        #endregion

        #region fooling around
        /// <info>
        /// testarea
        /// </info>

        private int foolingAround1()
        {
            int reachMoney = 9999999;
            var bridge = 0;
            var one__ = foolingAround1(saveMoneyCount[0], 64);
            if (saveMoneyCount[2] == 0) bridge = saveMoneyCount[1];
            var two__ = (Math.Pow(saveMoneyCount[1], saveMoneyCount[2]) + 65536 + bridge) * 4;
            var three = foolingAround1(saveMoneyCount[3], 64) * 1048576;

            var value = one__ + two__ + three;

            //label1.Text = value.ToString("n0");
            //label2.Text = (reachMoney).ToString("n0");
            //label3.Text = "diff: " + (reachMoney - value).ToString("n2");



            return 1;
        }

        int foolingAround1(int _x, int _y)
        {
            int e = 0;
            while ((_x % _y) == 0)
            {
                _x /= _y;
                e++;
            }
            return e;
        }
        int foolingAround2(int _x, int _y)
        {
            int e = 0;
            while ((_x - _y) > 0)
            {
                _x -= _y;
                e++;
            }
            return e;
        }
        // 262481 == 40-54-00-41
        //4194300 == 00-FF-FF-4F
        private void foolingAround_TextChanged(object sender, EventArgs e)
        {
            string BEEA = "0";
            string BEEB = "0";
            string BEEC = "0";
            string BEED = "0";


            //read textbox and splitt it for the following steps
            string latest = textBox1.Text.Substring(textBox1.TextLength - 1, 1);
            string left = textBox1.Text.Substring(0, textBox1.TextLength - 1) + "0";


            //calc
            BEEA = (Convert.ToInt16(latest) * 0x40).ToString("X");
            string tmp1 = "" + ((Convert.ToInt64(left) / 4) - 65536).ToString("X");

            int decAgain = int.Parse(BEEC, System.Globalization.NumberStyles.HexNumber);
            int tmp44 = (Convert.ToInt32(textBox1.Text) - 65536);
            int tmp45 = foolingAround2((Convert.ToInt32(textBox1.Text) - 65536), 100000) - 1;

            BEED = (0x40 + (foolingAround2(Convert.ToInt32(textBox1.Text) - 65536 , 100000) )).ToString("X");

            //prep4view
            if (BEEA.Length < 2) BEEA = "0" + BEEA;
            if (tmp1.Length > 4) tmp1 = tmp1.Substring(tmp1.Length - 4, 4);
            if (tmp1.Length <= 2) { BEEB = tmp1; BEEC = "00"; }
            if (tmp1.Length > 2) { BEEB = tmp1.Substring(tmp1.Length - 2, 2); BEEC = tmp1.Substring(0, tmp1.Length - 2); }

            label4.Text = BEEA + "-" + BEEB + "-" + BEEC + "-" + BEED;
            label5.Text = textBox1.Text;
        }

        #endregion

        

        





    }
}
    